module Main where

-- this runs really badly
-- mostly because i was too lazy to use a map

import Data.List

main :: IO ()
main = do
  raw <- getContents
  let input = map (map (read . (:[]))) $ lines raw
    in do
      putStrLn $ "day8a: " ++ (show $ solveA input)
      putStrLn $ "day8b: " ++ (show $ solveB input)

solveA :: [[Int]] -> Int
solveA db' = sum $ map ((+ 1) . snd) $ filter (isLow db) db
  where
    db = toMap db'

solveB :: [[Int]] -> Int
solveB db' = product $ take 3 $ reverse $ sort
  $ map (length . (findBasin (filter (\((_,_),v) -> v /= 9) db))) lps
  where
    lps = filter (isLow db) db
    db = toMap db'

findBasin :: [((Int,Int),Int)] -> ((Int,Int),Int) -> [((Int,Int),Int)]
findBasin db p = nub $ p : concat (map (findBasin db) $ filter isNb db)
  where
    isNb (c,v) = c `elem` (deltas (fst p)) && v > (snd p)

toMap :: [[Int]] -> [((Int,Int),Int)]
toMap [] = []
toMap rows = concat $ map f $ zip [0..] rows
  where
    f (i,v) = map (g i) $ zip [0..] v
    g i (j,v) = ((i,j), v)

deltas :: (Int,Int) -> [(Int,Int)]
deltas (x,y) =
  [ ((x-1),y)
  , ((x+1),y)
  , (x,(y-1))
  , (x,(y+1))
  ]

isLow :: [((Int,Int),Int)] -> ((Int,Int),Int) -> Bool
isLow db ((x,y),v) = all (> v) nbs
  where
    mbs = map (\p -> lookup p db) (deltas (x,y))
    nbs = [ x | Just x <- mbs ]

